Index: trunk/src/libs/libpng-1.6.43/configure
===================================================================
--- trunk/src/libs/libpng-1.6.43/configure	(revision 105468)
+++ trunk/src/libs/libpng-1.6.43/configure	(revision 105469)
@@ -1,5 +1,5 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.72 for libpng 1.6.42.
+# Generated by GNU Autoconf 2.72 for libpng 1.6.43.
 #
 # Report bugs to <png-mng-implement@lists.sourceforge.net>.
@@ -615,6 +615,6 @@
 PACKAGE_NAME='libpng'
 PACKAGE_TARNAME='libpng'
-PACKAGE_VERSION='1.6.42'
-PACKAGE_STRING='libpng 1.6.42'
+PACKAGE_VERSION='1.6.43'
+PACKAGE_STRING='libpng 1.6.43'
 PACKAGE_BUGREPORT='png-mng-implement@lists.sourceforge.net'
 PACKAGE_URL=''
@@ -868,4 +868,5 @@
 CPP
 LT_SYS_LIBRARY_PATH
+AWK
 PNG_COPTS'
 
@@ -1417,5 +1418,5 @@
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-'configure' configures libpng 1.6.42 to adapt to many kinds of systems.
+'configure' configures libpng 1.6.43 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
@@ -1488,5 +1489,5 @@
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of libpng 1.6.42:";;
+     short | recursive ) echo "Configuration of libpng 1.6.43:";;
    esac
   cat <<\_ACEOF
@@ -1544,7 +1545,7 @@
                           change this.
   --enable-hardware-optimizations
-                          Enable hardware optimizations: =no/off, yes/on:
+                          Enable hardware optimizations: =no/off, yes/on.
   --enable-arm-neon     Enable ARM NEON optimizations: =no/off, check, api,
-                          yes/on: no/off: disable the optimizations; check:
+                          yes/on. no/off: disable the optimizations; check:
                           use internal checking code (deprecated and poorly
                           supported); api: disable by default, enable by a
@@ -1553,5 +1554,5 @@
                           compiler.
   --enable-mips-msa     Enable MIPS MSA optimizations: =no/off, check, api,
-                          yes/on: no/off: disable the optimizations; check:
+                          yes/on. no/off: disable the optimizations; check:
                           use internal checking code (deprecated and poorly
                           supported); api: disable by default, enable by a
@@ -1560,5 +1561,5 @@
                           compiler.
   --enable-mips-mmi     Enable MIPS MMI optimizations: =no/off, check, api,
-                          yes/on: no/off: disable the optimizations; check:
+                          yes/on. no/off: disable the optimizations; check:
                           use internal checking code (deprecated and poorly
                           supported); api: disable by default, enable by a
@@ -1566,12 +1567,12 @@
                           unconditionally. If not specified: determined by the
                           compiler.
-  --enable-intel-sse    Enable Intel SSE optimizations: =no/off, yes/on:
+  --enable-intel-sse    Enable Intel SSE optimizations: =no/off, yes/on.
                           no/off: disable the optimizations; yes/on: enable
                           the optimizations. If not specified: determined by
                           the compiler.
   --enable-powerpc-vsx  Enable POWERPC VSX optimizations: =no/off, check,
-                          api, yes/on: no/off: disable the optimizations;
-                          check: use internal checking code api: disable by
-                          default, enable by a call to png_set_option yes/on:
+                          api, yes/on. no/off: disable the optimizations;
+                          check: use internal checking code; api: disable by
+                          default, enable by a call to png_set_option; yes/on:
                           turn on unconditionally. If not specified:
                           determined by the compiler.
@@ -1614,5 +1615,6 @@
   LT_SYS_LIBRARY_PATH
               User-defined run-time library search path.
-  PNG_COPTS   additional flags for the C compiler, use this for options that
+  AWK         AWK language processor
+  PNG_COPTS   additional flags for the C compiler, to be used for options that
               would cause configure itself to fail
 
@@ -1684,5 +1686,5 @@
 if $ac_init_version; then
   cat <<\_ACEOF
-libpng configure 1.6.42
+libpng configure 1.6.43
 generated by GNU Autoconf 2.72
 
@@ -1947,5 +1949,5 @@
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by libpng $as_me 1.6.42, which was
+It was created by libpng $as_me 1.6.43, which was
 generated by GNU Autoconf 2.72.  Invocation command line was
 
@@ -3247,5 +3249,5 @@
 # Define the identity of the package.
  PACKAGE='libpng'
- VERSION='1.6.42'
+ VERSION='1.6.43'
 
 
@@ -3380,8 +3382,8 @@
 
 
-PNGLIB_VERSION=1.6.42
+PNGLIB_VERSION=1.6.43
 PNGLIB_MAJOR=1
 PNGLIB_MINOR=6
-PNGLIB_RELEASE=41
+PNGLIB_RELEASE=43
 
 
@@ -3390,5 +3392,5 @@
 
 
-# Checks for programs.
+# Check for basic programs.
 ac_ext=c
 ac_cpp='$CPP $CPPFLAGS'
@@ -13660,18 +13662,20 @@
 
 
-# Some awks crash when confronted with pnglibconf.dfa, do a test run now
-# to make sure this doesn't happen
-{ printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking that AWK works" >&5
-printf %s "checking that AWK works... " >&6; }
+
+
+# Some awk implementations crash when confronted with pnglibconf.dfa.
+# Run a test now, to make sure this doesn't happen.
+{ printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking if awk ($AWK) works" >&5
+printf %s "checking if awk ($AWK) works... " >&6; }
 if ${AWK} -f ${srcdir}/scripts/options.awk out="/dev/null" version=search\
    ${srcdir}/pngconf.h ${srcdir}/scripts/pnglibconf.dfa\
    ${srcdir}/pngusr.dfa 1>&2
 then
-   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: ok" >&5
-printf "%s\n" "ok" >&6; }
+   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+printf "%s\n" "yes" >&6; }
 else
    { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
 printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
-as_fn_error 1 "failed
+as_fn_error 1 "no
 See 'config.log' for more details" "$LINENO" 5; }
 fi
@@ -14224,7 +14228,7 @@
 printf %s "checking for symbol prefix... " >&6; }
     SYMBOL_PREFIX=`echo "PREFIX=__USER_LABEL_PREFIX__" \
-                  | ${CPP-${CC-gcc} -E} - 2>&1 \
-                  | ${EGREP-grep} "^PREFIX=" \
-                  | ${SED-sed} -e "s:^PREFIX=::" -e "s:__USER_LABEL_PREFIX__::"`
+                  | ${CPP:-${CC:-gcc} -E} - 2>&1 \
+                  | ${EGREP:-grep} "^PREFIX=" \
+                  | ${SED:-sed} -e "s:^PREFIX=::" -e "s:__USER_LABEL_PREFIX__::"`
 
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $SYMBOL_PREFIX" >&5
@@ -14426,8 +14430,6 @@
 
 
-# ARM
-# ===
-#
-# ARM NEON (SIMD) support.
+# ARM NEON
+# ========
 
 # Check whether --enable-arm-neon was given.
@@ -14454,12 +14456,13 @@
 printf "%s\n" "#define PNG_ARM_NEON_OPT 2" >>confdefs.h
 
-         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-arm-neon: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass -mfpu=neon
-            to the compiler." >&5
-printf "%s\n" "$as_me: WARNING: --enable-arm-neon: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass -mfpu=neon
-            to the compiler." >&2;};;
+         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-arm-neon: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-mfpu=neon' to the compiler." >&5
+printf "%s\n" "$as_me: WARNING: --enable-arm-neon: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-mfpu=neon' to the compiler." >&2;};;
       *)
-         as_fn_error $? "--enable-arm-neon=${enable_arm_neon}: invalid value" "$LINENO" 5
+         as_fn_error $? "--enable-arm-neon=${enable_arm_neon}:
+                      invalid argument" "$LINENO" 5
    esac
 fi
@@ -14467,6 +14470,6 @@
 
 # Add ARM-specific files to all builds where $host_cpu is arm ('arm*') or
-# where ARM optimizations were explicitly requested (this allows a fallback
-# if a future host CPU does not match 'arm*')
+# where ARM optimizations were explicitly requested. (This allows a fallback
+# if a future host CPU does not match 'arm*'.)
 
  if test "$enable_arm_neon" != 'no' &&
@@ -14483,8 +14486,6 @@
 
 
-# MIPS
-# ====
-#
-# MIPS MSA (SIMD) support.
+# MIPS MSA
+# ========
 
 # Check whether --enable-mips-msa was given.
@@ -14511,12 +14512,13 @@
 printf "%s\n" "#define PNG_MIPS_MSA_OPT 2" >>confdefs.h
 
-         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-mips-msa: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-mmsa -mfp64'
-            to the compiler." >&5
-printf "%s\n" "$as_me: WARNING: --enable-mips-msa: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-mmsa -mfp64'
-            to the compiler." >&2;};;
+         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-mips-msa: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-mmsa -mfp64' to the compiler." >&5
+printf "%s\n" "$as_me: WARNING: --enable-mips-msa: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-mmsa -mfp64' to the compiler." >&2;};;
       *)
-         as_fn_error $? "--enable-mips-msa=${enable_mips_msa}: invalid value" "$LINENO" 5
+         as_fn_error $? "--enable-mips-msa=${enable_mips_msa}:
+                      invalid argument" "$LINENO" 5
    esac
 fi
@@ -14524,6 +14526,6 @@
 
 # Add MIPS-specific files to all builds where $host_cpu is mips ('mips*') or
-# where MIPS optimizations were explicitly requested (this allows a fallback
-# if a future host CPU does not match 'mips*')
+# where MIPS optimizations were explicitly requested. (This allows a fallback
+# if a future host CPU does not match 'mips*'.)
 
  if test "$enable_mips_msa" != 'no' &&
@@ -14539,8 +14541,6 @@
 
 
-# MIPS
-# ===
-#
-# MIPS MMI (SIMD) support.
+# MIPS MMI
+# ========
 
 # Check whether --enable-mips-mmi was given.
@@ -14567,12 +14567,13 @@
 printf "%s\n" "#define PNG_MIPS_MMI_OPT 1" >>confdefs.h
 
-         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-mips-mmi: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-mloongson-mmi -march=loongson3a'
-            to the compiler." >&5
-printf "%s\n" "$as_me: WARNING: --enable-mips-mmi: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-mloongson-mmi -march=loongson3a'
-            to the compiler." >&2;};;
+         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-mips-mmi: please specify 'check' or 'api';
+            if you want the optimizations unconditionally
+            pass '-mloongson-mmi -march=loongson3a' to the compiler." >&5
+printf "%s\n" "$as_me: WARNING: --enable-mips-mmi: please specify 'check' or 'api';
+            if you want the optimizations unconditionally
+            pass '-mloongson-mmi -march=loongson3a' to the compiler." >&2;};;
       *)
-         as_fn_error $? "--enable-mips-mmi=${enable_mips_mmi}: invalid value" "$LINENO" 5
+         as_fn_error $? "--enable-mips-mmi=${enable_mips_mmi}:
+                      invalid argument" "$LINENO" 5
    esac
 fi
@@ -14580,10 +14581,10 @@
 
 # Add MIPS specific files to all builds where the host_cpu is mips ('mips*') or
-# where MIPS optimizations were explicitly requested (this allows a fallback if a
-# future host CPU does not match 'mips*')
+# where MIPS optimizations were explicitly requested. (This allows a fallback
+# if a future host CPU does not match 'mips*'.)
 
  if test "$enable_mips_mmi" != 'no' &&
     case "$host_cpu" in
-      mipsel*|mips64el*) :;;
+      mipsel*|mips64el*) : ;;
     esac; then
   PNG_MIPS_MMI_TRUE=
@@ -14595,8 +14596,6 @@
 
 
-# INTEL
-# =====
-#
-# INTEL SSE (SIMD) support.
+# INTEL SSE
+# =========
 
 # Check whether --enable-intel-sse was given.
@@ -14616,5 +14615,6 @@
 ;;
       *)
-         as_fn_error $? "--enable-intel-sse=${enable_intel_sse}: invalid value" "$LINENO" 5
+         as_fn_error $? "--enable-intel-sse=${enable_intel_sse}:
+                      invalid argument" "$LINENO" 5
    esac
 fi
@@ -14622,6 +14622,6 @@
 
 # Add Intel-specific files to all builds where $host_cpu is Intel ('x86*') or
-# where Intel optimizations were explicitly requested (this allows a fallback
-# if a future host CPU does not match 'x86*')
+# where Intel optimizations were explicitly requested. (This allows a fallback
+# if a future host CPU does not match 'x86*'.)
  if test "$enable_intel_sse" != 'no' &&
     case "$host_cpu" in
@@ -14637,8 +14637,6 @@
 
 
-# PowerPC
-# =======
-#
-# PowerPC VSX (SIMD) support.
+# POWERPC VSX
+# ===========
 
 # Check whether --enable-powerpc-vsx was given.
@@ -14657,8 +14655,8 @@
 printf "%s\n" "#define PNG_POWERPC_VSX_CHECK_SUPPORTED /**/" >>confdefs.h
 
-         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-powerpc-vsx Please check contrib/powerpc/README file
-            for the list of supported OSes." >&5
-printf "%s\n" "$as_me: WARNING: --enable-powerpc-vsx Please check contrib/powerpc/README file
-            for the list of supported OSes." >&2;};;
+         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-powerpc-vsx: please see contrib/powerpc/README
+                     for the list of supported systems." >&5
+printf "%s\n" "$as_me: WARNING: --enable-powerpc-vsx: please see contrib/powerpc/README
+                     for the list of supported systems." >&2;};;
       api)
 
@@ -14669,19 +14667,20 @@
 printf "%s\n" "#define PNG_POWERPC_VSX_OPT 2" >>confdefs.h
 
-         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-powerpc-vsx: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-maltivec -mvsx'
-            or '-mcpu=power8' to the compiler." >&5
-printf "%s\n" "$as_me: WARNING: --enable-powerpc-vsx: please specify 'check' or 'api', if
-            you want the optimizations unconditionally pass '-maltivec -mvsx'
-            or '-mcpu=power8' to the compiler." >&2;};;
+         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: --enable-powerpc-vsx: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-maltivec -mvsx' or '-mcpu=power8' to the compiler." >&5
+printf "%s\n" "$as_me: WARNING: --enable-powerpc-vsx: please specify 'check' or 'api';
+            if you want the optimizations unconditionally,
+            pass '-maltivec -mvsx' or '-mcpu=power8' to the compiler." >&2;};;
       *)
-         as_fn_error $? "--enable-powerpc-vsx=${enable_powerpc_vsx}: invalid value" "$LINENO" 5
+         as_fn_error $? "--enable-powerpc-vsx=${enable_powerpc_vsx}:
+                      invalid argument" "$LINENO" 5
    esac
 fi
 
 
-# Add PowerPC-specific files to all builds where $host_cpu is powerpc('powerpc*')
-# or where PowerPC optimizations were explicitly requested (this allows a fallback
-# if a future host CPU does not match 'powerpc*')
+# Add PowerPC-specific files to all builds where $host_cpu is powerpc
+# ('powerpc*') or where PowerPC optimizations were explicitly requested.
+# (This allows a fallback if a future host CPU does not match 'powerpc*'.)
 
  if test "$enable_powerpc_vsx" != 'no' &&
@@ -14697,26 +14696,50 @@
 
 
-# LOONGARCH
-# ===
-#
-# LOONGARCH LSX (SIMD) support
-
-if test "$LSX_CFLAGS" = ''; then
-    LSX_CFLAGS="-mlsx"
-fi
-
-compiler_support_loongarch_lsx=no
-{ printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking whether to use loongarch LSX intrinsics" >&5
-printf %s "checking whether to use loongarch LSX intrinsics... " >&6; }
-save_CFLAGS=$CFLAGS
-CFLAGS="$CFLAGS $LSX_CFLAGS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+# LOONGARCH LSX
+# =============
+
+# Check whether --enable-loongarch-lsx was given.
+if test ${enable_loongarch_lsx+y}
+then :
+  enableval=$enable_loongarch_lsx; case "$enableval" in
+      no|off)
+         # disable the default enabling on __loongarch_simd systems:
+
+printf "%s\n" "#define PNG_LOONGARCH_LSX_OPT 0" >>confdefs.h
+
+         # Prevent inclusion of the assembler files below:
+         enable_loongarch_lsx=no;;
+      yes|on)
+
+printf "%s\n" "#define PNG_LOONGARCH_LSX_OPT 1" >>confdefs.h
+
+         ;;
+      *)
+         as_fn_error $? "--enable-loongarch-lsx=${enable_loongarch_lsx}:
+                      invalid argument" "$LINENO" 5
+   esac
+fi
+
+
+if test "$enable_loongarch_lsx" != "no" &&
+   case "$host_cpu" in
+      loongarch*) : ;;
+      *)    test "$enable_loongarch_lsx" != '' ;;
+   esac
+then
+   compiler_support_loongarch_lsx=no
+   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking whether to use LoongArch LSX intrinsics" >&5
+printf %s "checking whether to use LoongArch LSX intrinsics... " >&6; }
+   save_CFLAGS="$CFLAGS"
+   LSX_CFLAGS="${LSX_CFLAGS:-"-mlsx"}"
+   CFLAGS="$CFLAGS $LSX_CFLAGS"
+   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
-#include<lsxintrin.h>
+#include <lsxintrin.h>
 int main(){
-    __m128i a, b, c;
-    a = __lsx_vadd_w(b, c);
-    return 0;
+   __m128i a, b, c;
+   a = __lsx_vadd_w(b, c);
+   return 0;
 }
 _ACEOF
@@ -14726,32 +14749,8 @@
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-CFLAGS=$save_CFLAGS
-{ printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $compiler_support_loongarch_lsx" >&5
+   CFLAGS="$save_CFLAGS"
+   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $compiler_support_loongarch_lsx" >&5
 printf "%s\n" "$compiler_support_loongarch_lsx" >&6; }
-
-# Check whether --enable-loongarch-lsx was given.
-if test ${enable_loongarch_lsx+y}
-then :
-  enableval=$enable_loongarch_lsx; case "$enableval" in
-      no|off)
-         # disable the default enabling on __loongarch_simd systems:
-
-printf "%s\n" "#define PNG_LOONGARCH_LSX_OPT 0" >>confdefs.h
-
-         # Prevent inclusion of the assembler files below:
-         enable_loongarch_lsx=no;;
-      yes|on)
-
-printf "%s\n" "#define PNG_LOONGARCH_LSX_OPT 1" >>confdefs.h
-
-         ;;
-      *)
-         as_fn_error $? "--enable-loongarch-lsx=${enable_loongarch_lsx}: invalid value" "$LINENO" 5
-   esac
-fi
-
-
-if test "$enable_loongarch_lsx" != 'no'; then
-   if test $compiler_support_loongarch_lsx = yes; then
+   if test "$compiler_support_loongarch_lsx" = "yes"; then
 
 printf "%s\n" "#define PNG_LOONGARCH_LSX_OPT 1" >>confdefs.h
@@ -14763,12 +14762,13 @@
 fi
 
-# Add LOONGARCH specific files to all builds where the host_cpu is loongarch ('loongarch*') or
-# where LOONGARCH optimizations were explicitly requested (this allows a fallback if a
-# future host CPU does not match 'loongarch*')
-
- if test "$enable_loongarch_lsx" != 'no' && test $compiler_support_loongarch_lsx = yes &&
+# Add LoongArch specific files to all builds where the host_cpu is loongarch
+# ('loongarch*') or where LoongArch optimizations were explicitly requested.
+# (This allows a fallback if a future host CPU does not match 'loongarch*'.)
+
+ if test "$enable_loongarch_lsx" != "no" &&
+    test "$compiler_support_loongarch_lsx" = "yes" &&
     case "$host_cpu" in
-      loongarch*) :;;
-      *)    test "$enable_loongarch_lsx" != '';;
+      loongarch*) : ;;
+      *)    test "$enable_loongarch_lsx" != '' ;;
     esac; then
   PNG_LOONGARCH_LSX_TRUE=
@@ -15383,5 +15383,5 @@
 # values after options handling.
 ac_log="
-This file was extended by libpng $as_me 1.6.42, which was
+This file was extended by libpng $as_me 1.6.43, which was
 generated by GNU Autoconf 2.72.  Invocation command line was
 
@@ -15451,5 +15451,5 @@
 ac_cs_config='$ac_cs_config_escaped'
 ac_cs_version="\\
-libpng config.status 1.6.42
+libpng config.status 1.6.43
 configured by $0, generated by GNU Autoconf 2.72,
   with options \\"\$ac_cs_config\\"