Index: trunk/doc/manual/common-formatcfg.xsl
===================================================================
--- trunk/doc/manual/common-formatcfg.xsl	(revision 105473)
+++ trunk/doc/manual/common-formatcfg.xsl	(revision 105474)
@@ -107,64 +107,4 @@
 </xsl:template>
 
-<!--
-  refentry related layout tweaks.
-
-  Note! While we could save us all this work by using refsect1..3 and
-        refsynopsisdiv docbook-refentry-to-manual-sect1.xsl, we'd like to have
-        a valid XML document and thus do do some extra markup using the role
-        and condition attributes.  We catch some of it here.  But the XSLT
-        for specific targets (html, latex, etc) have a few more tweaks
-        related to this.
-
-        The @role has only one special trick 'not-in-toc' that excludes sections
-        like 'Synopsis' and 'Description' from the TOCs.
-
-        The @condition records the original refentry element name, i.e. it will
-        have values like refentry, refsynopsisdiv, refsect1, refsect2 and refsect3.
-  -->
-
-<!-- This removes the not-in-toc bits from the toc. -->
-<xsl:template match="sect2[@role = 'not-in-toc']"      mode="toc" />
-<xsl:template match="sect3[@role = 'not-in-toc']"      mode="toc" />
-<xsl:template match="sect4[@role = 'not-in-toc']"      mode="toc" />
-<xsl:template match="sect5[@role = 'not-in-toc']"      mode="toc" />
-<xsl:template match="section[@role = 'not-in-toc']"    mode="toc" />
-<xsl:template match="simplesect[@role = 'not-in-toc']" mode="toc" />
-
-<!-- This removes unnecessary <dd><dl> stuff caused by the above. -->
-<xsl:template match="sect1[sect2/@role = 'not-in-toc']" mode="toc">
-  <xsl:param name="toc-context" select="."/>
-  <xsl:call-template name="subtoc">
-    <xsl:with-param name="toc-context" select="$toc-context"/>
-    <xsl:with-param name="nodes" select="sect2[@role != 'not-in-toc'] | bridgehead[$bridgehead.in.toc != 0]"/>
-  </xsl:call-template>
-</xsl:template>
-
-<xsl:template match="sect2[sect3/@role = 'not-in-toc']" mode="toc">
-  <xsl:param name="toc-context" select="."/>
-  <xsl:call-template name="subtoc">
-    <xsl:with-param name="toc-context" select="$toc-context"/>
-    <xsl:with-param name="nodes" select="sect3[@role != 'not-in-toc'] | bridgehead[$bridgehead.in.toc != 0]"/>
-  </xsl:call-template>
-</xsl:template>
-
-<!-- This make the refsect* and refsynopsisdiv unnumbered like the default refentry rendering. -->
-<xsl:template match="sect2[@condition = 'refsynopsisdiv']
-                   | sect2[starts-with(@condition, 'refsect')]
-                   | sect3[starts-with(@condition, 'refsect')]
-                   | sect4[starts-with(@condition, 'refsect')]
-                   | sect5[starts-with(@condition, 'refsect')]
-                   | section[starts-with(@condition, 'refsect')]
-                   | simplesect[starts-with(@condition, 'refsect')]"
-  mode="object.title.template"
-  >
-    <xsl:call-template name="gentext.template">
-      <xsl:with-param name="context" select="'title-unnumbered'"/>
-      <xsl:with-param name="name">
-        <xsl:call-template name="xpath.location"/>
-      </xsl:with-param>
-    </xsl:call-template>
-</xsl:template>
-
 
 </xsl:stylesheet>
Index: trunk/doc/manual/common-html-formatcfg.xsl
===================================================================
--- trunk/doc/manual/common-html-formatcfg.xsl	(revision 105473)
+++ trunk/doc/manual/common-html-formatcfg.xsl	(revision 105474)
@@ -122,60 +122,4 @@
 
 
-<!-- This is for allow special CSS rules to apply to the refsect stuff. -->
-<xsl:template match="sect2[     @role      = 'not-in-toc']/title
-                   | sect3[     @role      = 'not-in-toc']/title
-                   | sect4[     @role      = 'not-in-toc']/title
-                   | sect5[     @role      = 'not-in-toc']/title
-                   | section[   @role      = 'not-in-toc']/title
-                   | simplesect[@role      = 'not-in-toc']/title
-                   | sect1[     @condition = 'refentry']/title
-                   | sect2[     @condition = 'refentry']/title
-                   | sect1[     starts-with(@condition, 'refsect')]/title
-                   | sect2[     starts-with(@condition, 'refsect')]/title
-                   | sect3[     starts-with(@condition, 'refsect')]/title
-                   | sect4[     starts-with(@condition, 'refsect')]/title
-                   | sect5[     starts-with(@condition, 'refsect')]/title
-                   | section[   starts-with(@condition, 'refsect')]/title
-                   | simplesect[starts-with(@condition, 'refsect')]/title
-" mode="titlepage.mode">
-  <xsl:element name="div">
-    <xsl:attribute name="class">
-      <xsl:value-of select="../@role"/>
-      <xsl:if test="../@role and ../@condition">
-        <xsl:text> </xsl:text>
-      </xsl:if>
-      <xsl:value-of select="../@condition"/>
-    </xsl:attribute>
-    <xsl:apply-imports/>
-  </xsl:element>
-</xsl:template>
-
-<xsl:template match="sect2[     @role      = 'not-in-toc']
-                   | sect3[     @role      = 'not-in-toc']
-                   | sect4[     @role      = 'not-in-toc']
-                   | sect5[     @role      = 'not-in-toc']
-                   | section[   @role      = 'not-in-toc']
-                   | simplesect[@role      = 'not-in-toc']
-                   | sect1[     @condition = 'refentry']
-                   | sect2[     @condition = 'refentry']
-                   | sect1[     starts-with(@condition, 'refsect')]
-                   | sect2[     starts-with(@condition, 'refsect')]
-                   | sect3[     starts-with(@condition, 'refsect')]
-                   | sect4[     starts-with(@condition, 'refsect')]
-                   | sect5[     starts-with(@condition, 'refsect')]
-                   | section[   starts-with(@condition, 'refsect')]
-                   | simplesect[starts-with(@condition, 'refsect')]" >
-  <xsl:element name="div">
-    <xsl:attribute name="class">
-      <xsl:value-of select="@role"/>
-      <xsl:if test="@role and @condition">
-        <xsl:text> </xsl:text>
-      </xsl:if>
-      <xsl:value-of select="@condition"/>
-    </xsl:attribute>
-    <xsl:apply-imports/>
-  </xsl:element>
-</xsl:template>
-
 <!-- To use CSS to correctly insert hanging indent when soft wrapping and
   <sbr>'ing a synopsis, we must place each command in its own <p>.  The default
Index: trunk/doc/manual/docbook-refentry-to-C-help.xsl
===================================================================
--- trunk/doc/manual/docbook-refentry-to-C-help.xsl	(revision 105473)
+++ trunk/doc/manual/docbook-refentry-to-C-help.xsl	(revision 105474)
@@ -1,5 +1,5 @@
 <?xml version="1.0"?>
 <!--
-    docbook-refentry-to-manual-sect1.xsl:
+    docbook-refentry-to-C-help.xsl:
         XSLT stylesheet for nicking the refsynopsisdiv bit of a
         refentry (manpage) for use in the command overview section
Index: trunk/doc/manual/docbook-refentry-to-manual-dita.xsl
===================================================================
--- trunk/doc/manual/docbook-refentry-to-manual-dita.xsl	(revision 105473)
+++ trunk/doc/manual/docbook-refentry-to-manual-dita.xsl	(revision 105474)
@@ -1,5 +1,5 @@
 <?xml version="1.0"?>
 <!--
-    docbook-refentry-to-manual-sect1.xsl:
+    docbook-refentry-to-manual-dita.xsl:
         XSLT stylesheet for converting a refentry (manpage)
         to dita for use in the user manual.
@@ -50,5 +50,5 @@
            4.0.x with the latest com.elovirta.pdf plugin (2023-03-xx
            or later), we can enable this by default again. -->
-<xsl:param name="g_fReplaceHypens">false</xsl:param>
+<xsl:param name="g_fReplaceHyphens">true</xsl:param>
 
 <!-- Render the syntax diagram more as text than as proper markup. -->
@@ -769,5 +769,5 @@
 </xsl:template>
 
-<!-- replaceable/text() in a cmdsynopsis should have hypens replaced. -->
+<!-- replaceable/text() in a cmdsynopsis should have hyphens replaced. -->
 <xsl:template match="replaceable/text()[ancestor::cmdsynopsis]" >
   <xsl:call-template name="emit-text-with-replacements"/>
@@ -1084,10 +1084,10 @@
 
 <!--
- Maybe replace hypens (dashes) with non-breaking ones.
+ Maybe replace hyphens (dashes) with non-breaking ones.
  -->
 <xsl:template name="emit-text-with-replacements">
   <xsl:param name="a_sText" select="."/>
   <xsl:choose>
-    <xsl:when test="$g_fReplaceHypens = 'true'">
+    <xsl:when test="$g_fReplaceHyphens = 'true'">
       <xsl:call-template name="str:subst">
           <xsl:with-param name="text" select="$a_sText"/>
Index: trunk/doc/manual/docbook-refentry-to-manual-sect1.xsl
===================================================================
--- trunk/doc/manual/docbook-refentry-to-manual-sect1.xsl	(revision 105473)
+++ 	(revision )
@@ -1,183 +1,0 @@
-<?xml version="1.0"?>
-<!--
-    docbook-refentry-to-manual-sect1.xsl:
-        XSLT stylesheet for transforming a refentry (manpage)
-        to a sect1 for the user manual.
--->
-<!--
-    Copyright (C) 2006-2023 Oracle and/or its affiliates.
-
-    This file is part of VirtualBox base platform packages, as
-    available from https://www.virtualbox.org.
-
-    This program is free software; you can redistribute it and/or
-    modify it under the terms of the GNU General Public License
-    as published by the Free Software Foundation, in version 3 of the
-    License.
-
-    This program is distributed in the hope that it will be useful, but
-    WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-    General Public License for more details.
-
-    You should have received a copy of the GNU General Public License
-    along with this program; if not, see <https://www.gnu.org/licenses>.
-
-    SPDX-License-Identifier: GPL-3.0-only
--->
-
-<xsl:stylesheet
-  version="1.0"
-  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-  xmlns:str="http://xsltsl.org/string"
-  >
-
-  <xsl:import href="string.xsl"/>
-
-  <xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes"/>
-  <xsl:strip-space elements="*"/>
-
-
-<!-- - - - - - - - - - - - - - - - - - - - - - -
-  global XSLT variables
- - - - - - - - - - - - - - - - - - - - - - - -->
-
-
-
-<!-- - - - - - - - - - - - - - - - - - - - - - -
-  base operation is to copy.
- - - - - - - - - - - - - - - - - - - - - - - -->
-
-<xsl:template match="node()|@*">
-  <xsl:copy>
-     <xsl:apply-templates select="node()|@*"/>
-  </xsl:copy>
-</xsl:template>
-
-
-<!-- - - - - - - - - - - - - - - - - - - - - - -
-
- - - - - - - - - - - - - - - - - - - - - - - -->
-
-<!-- rename refentry to sect1 -->
-<xsl:template match="refentry">
-  <xsl:element name="sect1">
-    <xsl:attribute name="condition">refentry</xsl:attribute>
-    <xsl:apply-templates select="node()|@*"/>
-  </xsl:element>
-</xsl:template>
-
-<!-- Remove refentryinfo, keeping the title element. -->
-<xsl:template match="refentryinfo">
-  <xsl:if test="./title">
-    <xsl:copy-of select="./title"/>
-  </xsl:if>
-</xsl:template>
-
-<!-- Morph refnamediv into a brief description. -->
-<xsl:template match="refnamediv">
-  <xsl:element name="para">
-    <xsl:call-template name="capitalize">
-      <xsl:with-param name="text" select="normalize-space(./refpurpose)"/>
-    </xsl:call-template>
-    <xsl:text>.</xsl:text>
-  </xsl:element>
-</xsl:template>
-
-<!-- Morph the refsynopsisdiv part into a synopsis section. -->
-<xsl:template match="refsynopsisdiv">
-  <xsl:if test="name(*[1]) != 'cmdsynopsis'"><xsl:message terminate="yes">Expected refsynopsisdiv to start with cmdsynopsis</xsl:message></xsl:if>
-  <xsl:if test="title"><xsl:message terminate="yes">No title element supported in refsynopsisdiv</xsl:message></xsl:if>
-
-  <xsl:element name="sect2">
-    <xsl:attribute name="role">not-in-toc</xsl:attribute>
-    <xsl:attribute name="condition">refsynopsisdiv</xsl:attribute>
-    <xsl:element name="title">
-    <xsl:text>Synopsis</xsl:text>
-    </xsl:element>
-    <xsl:apply-templates />
-  </xsl:element>
-
-</xsl:template>
-
-<!-- refsect1 -> sect2 -->
-<xsl:template match="refsect1">
-  <xsl:if test="not(title)"><xsl:message terminate="yes">refsect1 requires title</xsl:message></xsl:if>
-  <xsl:element name="sect2">
-    <xsl:attribute name="role">not-in-toc</xsl:attribute>
-    <xsl:attribute name="condition">refsect1</xsl:attribute>
-    <xsl:if test="@id">
-      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
-    </xsl:if>
-    <xsl:apply-templates />
-  </xsl:element>
-</xsl:template>
-
-<!-- refsect2 -> sect3 -->
-<xsl:template match="refsect2">
-  <xsl:if test="not(title)"><xsl:message terminate="yes">refsect2 requires title</xsl:message></xsl:if>
-  <xsl:element name="sect3">
-    <xsl:attribute name="role">not-in-toc</xsl:attribute>
-    <xsl:attribute name="condition">refsect2</xsl:attribute>
-    <xsl:if test="@id">
-      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
-    </xsl:if>
-    <xsl:apply-templates />
-  </xsl:element>
-</xsl:template>
-
-<!-- refsect3 -> sect4 -->
-<xsl:template match="refsect3">
-  <xsl:if test="not(title)"><xsl:message terminate="yes">refsect3 requires title</xsl:message></xsl:if>
-  <xsl:element name="sect4">
-    <xsl:attribute name="role">not-in-toc</xsl:attribute>
-    <xsl:attribute name="condition">refsect3</xsl:attribute>
-    <xsl:if test="@id">
-      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
-    </xsl:if>
-    <xsl:apply-templates />
-  </xsl:element>
-</xsl:template>
-
-
-<!-- Remove refmeta. -->
-<xsl:template match="refmeta"/>
-
-<!--
- remark extensions:
- -->
-<!-- Default: remove all remarks. -->
-<xsl:template match="remark"/>
-
-<!-- help-manual - stuff that should only be included in the manual. -->
-<xsl:template match="remark[@role = 'help-manual']">
-  <xsl:apply-templates/>
-</xsl:template>
-
-<!-- help-copy-synopsis - used in refsect2 to copy synopsis from the refsynopsisdiv. -->
-<xsl:template match="remark[@role = 'help-copy-synopsis']">
-  <xsl:if test="not(parent::refsect2)">
-    <xsl:message terminate="yes">The help-copy-synopsis remark is only applicable in refsect2.</xsl:message>
-  </xsl:if>
-  <xsl:variable name="sSrcId" select="concat('synopsis-',../@id)"/>
-  <xsl:if test="not(/refentry/refsynopsisdiv/cmdsynopsis[@id = $sSrcId])">
-    <xsl:message terminate="yes">Could not find any cmdsynopsis with id=<xsl:value-of select="$sSrcId"/> in refsynopsisdiv.</xsl:message>
-  </xsl:if>
-  <xsl:element name="cmdsynopsis">
-    <xsl:copy-of select="/refentry/refsynopsisdiv/cmdsynopsis[@id = $sSrcId]/node()"/>
-  </xsl:element>
-</xsl:template>
-
-<!--
- Captializes the given text.
- -->
-<xsl:template name="capitalize">
-  <xsl:param name="text"/>
-  <xsl:call-template name="str:to-upper">
-    <xsl:with-param name="text" select="substring($text,1,1)"/>
-  </xsl:call-template>
-  <xsl:value-of select="substring($text,2)"/>
-</xsl:template>
-
-</xsl:stylesheet>
-
Index: trunk/doc/manual/docbook2latex.xsl
===================================================================
--- trunk/doc/manual/docbook2latex.xsl	(revision 105473)
+++ trunk/doc/manual/docbook2latex.xsl	(revision 105474)
@@ -390,9 +390,4 @@
         </xsl:call-template>
       </xsl:when>
-      <xsl:when test="parent::sect2[@role='not-in-toc'] or parent::refsect1 or (parent::section and count(ancestor::section) = 2)">
-        <xsl:call-template name="title-wrapper">
-          <xsl:with-param name="texcmd">\subsection*</xsl:with-param>
-        </xsl:call-template>
-      </xsl:when>
       <xsl:when test="name(..)='sect2'">
         <xsl:call-template name="title-wrapper">
@@ -400,9 +395,4 @@
         </xsl:call-template>
       </xsl:when>
-      <xsl:when test="parent::sect3[@role='not-in-toc'] or parent::refsect2 or (parent::section and count(ancestor::section) = 3)">
-        <xsl:call-template name="title-wrapper">
-          <xsl:with-param name="texcmd">\subsubsection*</xsl:with-param>
-        </xsl:call-template>
-      </xsl:when>
       <xsl:when test="name(..)='sect3'">
         <xsl:call-template name="title-wrapper">
@@ -410,17 +400,7 @@
         </xsl:call-template>
       </xsl:when>
-      <xsl:when test="parent::sect4[@role='not-in-toc'] or parent::refsect3 or (parent::section and count(ancestor::section) = 4)">
-        <xsl:call-template name="title-wrapper">
-          <xsl:with-param name="texcmd">\paragraph*</xsl:with-param>
-        </xsl:call-template>
-      </xsl:when>
       <xsl:when test="name(..)='sect4'">
         <xsl:call-template name="title-wrapper">
           <xsl:with-param name="texcmd">\paragraph</xsl:with-param>
-        </xsl:call-template>
-      </xsl:when>
-      <xsl:when test="parent::sect5[@role='not-in-toc'] or parent::refsect4 or (parent::section and count(ancestor::section) = 5)">
-        <xsl:call-template name="title-wrapper">
-          <xsl:with-param name="texcmd">\subparagraph*</xsl:with-param>
         </xsl:call-template>
       </xsl:when>
Index: trunk/doc/manual/ru_RU/docbook-refentry-to-C-help.xsl
===================================================================
--- trunk/doc/manual/ru_RU/docbook-refentry-to-C-help.xsl	(revision 105473)
+++ trunk/doc/manual/ru_RU/docbook-refentry-to-C-help.xsl	(revision 105474)
@@ -1,5 +1,5 @@
 <?xml version="1.0"?>
 <!--
-    docbook-refentry-to-manual-sect1.xsl:
+    docbook-refentry-to-C-help.xsl:
         XSLT stylesheet for nicking the refsynopsisdiv bit of a
         refentry (manpage) for use in the command overview section